diff --git a/sys/dev/drm/include/linux/sysrq.h b/sys/dev/drm/include/linux/sysrq.h
new file mode 100644
index 0000000000..ca782f5074
--- /dev/null
+++ b/sys/dev/drm/include/linux/sysrq.h
@@ -0,0 +1,49 @@
+/*	$NetBSD: sysrq.h,v 1.2 2014/03/18 18:20:43 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2013 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_SYSRQ_H_
+#define _LINUX_SYSRQ_H_
+
+struct sysrq_key_op {
+	char sko_blahdittyblahblah;
+};
+
+static inline void
+register_sysrq_key(char key __unused, struct sysrq_key_op *op __unused)
+{
+}
+
+static inline void
+unregister_sysrq_key(char key __unused, struct sysrq_key_op *op __unused)
+{
+}
+
+#endif  /* _LINUX_SYSRQ_H_ */
diff --git a/sys/dev/drm/include/linux/tracepoint.h b/sys/dev/drm/include/linux/tracepoint.h
new file mode 100644
index 0000000000..8df5b437d9
--- /dev/null
+++ b/sys/dev/drm/include/linux/tracepoint.h
@@ -0,0 +1,35 @@
+/*-
+ * Copyright (c) 2015 The DragonFly Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_TRACEPOINT_H
+#define _LINUX_TRACEPOINT_H
+
+#endif /* _LINUX_TRACEPOINT_H */
diff --git a/sys/dev/drm/include/linux/tty.h b/sys/dev/drm/include/linux/tty.h
new file mode 100644
index 0000000000..58d7f3e753
--- /dev/null
+++ b/sys/dev/drm/include/linux/tty.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: tty.h,v 1.2 2014/03/18 18:20:43 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2013 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_TTY_H_
+#define _LINUX_TTY_H_
+
+#endif  /* _LINUX_TTY_H_ */
diff --git a/sys/dev/drm/include/linux/vgaarb.h b/sys/dev/drm/include/linux/vgaarb.h
new file mode 100644
index 0000000000..6c110dabe7
--- /dev/null
+++ b/sys/dev/drm/include/linux/vgaarb.h
@@ -0,0 +1,49 @@
+/*	$NetBSD: vgaarb.h,v 1.3 2015/02/25 21:55:30 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2013 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_VGAARB_H_
+#define _LINUX_VGAARB_H_
+
+#include <sys/types.h>
+#include <sys/errno.h>
+#include <sys/stdbool.h>
+
+struct pci_dev;
+
+static inline int
+vga_client_register(struct pci_dev *pdev __unused, void *cookie __unused,
+    void (*irq_set_state)(void *, bool) __unused,
+    unsigned int (*set_vga_decode)(void *, bool) __unused)
+{
+	return -ENOSYS;
+}
+
+#endif  /* _LINUX_VGAARB_H_ */
diff --git a/sys/dev/drm/include/linux/workqueue.h b/sys/dev/drm/include/linux/workqueue.h
index 4c2f598cf4..989375e002 100644
--- a/sys/dev/drm/include/linux/workqueue.h
+++ b/sys/dev/drm/include/linux/workqueue.h
@@ -195,6 +195,13 @@ flush_taskqueue(struct taskqueue *tq)
 	PRELE(curproc);
 }
 
+static inline int
+flush_work(struct work_struct *work)
+{
+	taskqueue_drain(work->taskqueue, &work->work_task);
+	return 0;
+}
+
 static inline int
 cancel_work_sync(struct work_struct *work)
 {
diff --git a/sys/dev/drm/include/trace/define_trace.h b/sys/dev/drm/include/trace/define_trace.h
new file mode 100644
index 0000000000..02e1003568
--- /dev/null
+++ b/sys/dev/drm/include/trace/define_trace.h
@@ -0,0 +1,118 @@
+/*
+ * Trace files that want to automate creation of all tracepoints defined
+ * in their file should include this file. The following are macros that the
+ * trace file may define:
+ *
+ * TRACE_SYSTEM defines the system the tracepoint is for
+ *
+ * TRACE_INCLUDE_FILE if the file name is something other than TRACE_SYSTEM.h
+ *     This macro may be defined to tell define_trace.h what file to include.
+ *     Note, leave off the ".h".
+ *
+ * TRACE_INCLUDE_PATH if the path is something other than core kernel include/trace
+ *     then this macro can define the path to use. Note, the path is relative to
+ *     define_trace.h, not the file including it. Full path names for out of tree
+ *     modules must be used.
+ */
+
+#ifdef CREATE_TRACE_POINTS
+
+/* Prevent recursion */
+#undef CREATE_TRACE_POINTS
+
+#include <linux/stringify.h>
+
+#undef TRACE_EVENT
+#define TRACE_EVENT(name, proto, args, tstruct, assign, print)	\
+	DEFINE_TRACE(name)
+
+#undef TRACE_EVENT_CONDITION
+#define TRACE_EVENT_CONDITION(name, proto, args, cond, tstruct, assign, print) \
+	TRACE_EVENT(name,						\
+		PARAMS(proto),						\
+		PARAMS(args),						\
+		PARAMS(tstruct),					\
+		PARAMS(assign),						\
+		PARAMS(print))
+
+#undef TRACE_EVENT_FN
+#define TRACE_EVENT_FN(name, proto, args, tstruct,		\
+		assign, print, reg, unreg)			\
+	DEFINE_TRACE_FN(name, reg, unreg)
+
+#undef DEFINE_EVENT
+#define DEFINE_EVENT(template, name, proto, args) \
+	DEFINE_TRACE(name)
+
+#undef DEFINE_EVENT_FN
+#define DEFINE_EVENT_FN(template, name, proto, args, reg, unreg) \
+	DEFINE_TRACE_FN(name, reg, unreg)
+
+#undef DEFINE_EVENT_PRINT
+#define DEFINE_EVENT_PRINT(template, name, proto, args, print)	\
+	DEFINE_TRACE(name)
+
+#undef DEFINE_EVENT_CONDITION
+#define DEFINE_EVENT_CONDITION(template, name, proto, args, cond) \
+	DEFINE_EVENT(template, name, PARAMS(proto), PARAMS(args))
+
+#undef DECLARE_TRACE
+#define DECLARE_TRACE(name, proto, args)	\
+	DEFINE_TRACE(name)
+
+#undef TRACE_INCLUDE
+#undef __TRACE_INCLUDE
+
+#ifndef TRACE_INCLUDE_FILE
+# define TRACE_INCLUDE_FILE TRACE_SYSTEM
+# define UNDEF_TRACE_INCLUDE_FILE
+#endif
+
+#ifndef TRACE_INCLUDE_PATH
+# define __TRACE_INCLUDE(system) <trace/events/system.h>
+# define UNDEF_TRACE_INCLUDE_PATH
+#else
+# define __TRACE_INCLUDE(system) __stringify(TRACE_INCLUDE_PATH/system.h)
+#endif
+
+# define TRACE_INCLUDE(system) __TRACE_INCLUDE(system)
+
+/* Let the trace headers be reread */
+#define TRACE_HEADER_MULTI_READ
+
+#include TRACE_INCLUDE(TRACE_INCLUDE_FILE)
+
+/* Make all open coded DECLARE_TRACE nops */
+#undef DECLARE_TRACE
+#define DECLARE_TRACE(name, proto, args)
+
+#ifdef CONFIG_EVENT_TRACING
+#include <trace/ftrace.h>
+#endif
+
+#undef TRACE_EVENT
+#undef TRACE_EVENT_FN
+#undef TRACE_EVENT_CONDITION
+#undef DECLARE_EVENT_CLASS
+#undef DEFINE_EVENT
+#undef DEFINE_EVENT_FN
+#undef DEFINE_EVENT_PRINT
+#undef DEFINE_EVENT_CONDITION
+#undef TRACE_HEADER_MULTI_READ
+#undef DECLARE_TRACE
+
+/* Only undef what we defined in this file */
+#ifdef UNDEF_TRACE_INCLUDE_FILE
+# undef TRACE_INCLUDE_FILE
+# undef UNDEF_TRACE_INCLUDE_FILE
+#endif
+
+#ifdef UNDEF_TRACE_INCLUDE_PATH
+# undef TRACE_INCLUDE_PATH
+# undef UNDEF_TRACE_INCLUDE_PATH
+#endif
+
+/* We may be processing more files */
+#define CREATE_TRACE_POINTS
+
+#endif /* CREATE_TRACE_POINTS */
diff --git a/sys/dev/drm/include/trace/events/fence.h b/sys/dev/drm/include/trace/events/fence.h
new file mode 100644
index 0000000000..d05e4a8214
--- /dev/null
+++ b/sys/dev/drm/include/trace/events/fence.h
@@ -0,0 +1,35 @@
+/*-
+ * Copyright (c) 2015 The DragonFly Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _TRACE_FENCE_H
+#define _TRACE_FENCE_H
+
+#endif /* _TRACE_FENCE_H */
diff --git a/sys/dev/drm/include/uapi_drm/nouveau_drm.h b/sys/dev/drm/include/uapi_drm/nouveau_drm.h
new file mode 100644
index 0000000000..5507eead58
--- /dev/null
+++ b/sys/dev/drm/include/uapi_drm/nouveau_drm.h
@@ -0,0 +1,150 @@
+/*
+ * Copyright 2005 Stephane Marchesin.
+ * All Rights Reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * VA LINUX SYSTEMS AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
+ * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ */
+
+#ifndef __NOUVEAU_DRM_H__
+#define __NOUVEAU_DRM_H__
+
+#define DRM_NOUVEAU_EVENT_NVIF                                       0x80000000
+
+/* reserved object handles when using deprecated object APIs - these
+ * are here so that libdrm can allow interoperability with the new
+ * object APIs
+ */
+#define NOUVEAU_ABI16_CLIENT   0xffffffff
+#define NOUVEAU_ABI16_DEVICE   0xdddddddd
+#define NOUVEAU_ABI16_CHAN(n) (0xcccc0000 | (n))
+
+#define NOUVEAU_GEM_DOMAIN_CPU       (1 << 0)
+#define NOUVEAU_GEM_DOMAIN_VRAM      (1 << 1)
+#define NOUVEAU_GEM_DOMAIN_GART      (1 << 2)
+#define NOUVEAU_GEM_DOMAIN_MAPPABLE  (1 << 3)
+#define NOUVEAU_GEM_DOMAIN_COHERENT  (1 << 4)
+
+#define NOUVEAU_GEM_TILE_COMP        0x00030000 /* nv50-only */
+#define NOUVEAU_GEM_TILE_LAYOUT_MASK 0x0000ff00
+#define NOUVEAU_GEM_TILE_16BPP       0x00000001
+#define NOUVEAU_GEM_TILE_32BPP       0x00000002
+#define NOUVEAU_GEM_TILE_ZETA        0x00000004
+#define NOUVEAU_GEM_TILE_NONCONTIG   0x00000008
+
+struct drm_nouveau_gem_info {
+	uint32_t handle;
+	uint32_t domain;
+	uint64_t size;
+	uint64_t offset;
+	uint64_t map_handle;
+	uint32_t tile_mode;
+	uint32_t tile_flags;
+};
+
+struct drm_nouveau_gem_new {
+	struct drm_nouveau_gem_info info;
+	uint32_t channel_hint;
+	uint32_t align;
+};
+
+#define NOUVEAU_GEM_MAX_BUFFERS 1024
+struct drm_nouveau_gem_pushbuf_bo_presumed {
+	uint32_t valid;
+	uint32_t domain;
+	uint64_t offset;
+};
+
+struct drm_nouveau_gem_pushbuf_bo {
+	uint64_t user_priv;
+	uint32_t handle;
+	uint32_t read_domains;
+	uint32_t write_domains;
+	uint32_t valid_domains;
+	struct drm_nouveau_gem_pushbuf_bo_presumed presumed;
+};
+
+#define NOUVEAU_GEM_RELOC_LOW  (1 << 0)
+#define NOUVEAU_GEM_RELOC_HIGH (1 << 1)
+#define NOUVEAU_GEM_RELOC_OR   (1 << 2)
+#define NOUVEAU_GEM_MAX_RELOCS 1024
+struct drm_nouveau_gem_pushbuf_reloc {
+	uint32_t reloc_bo_index;
+	uint32_t reloc_bo_offset;
+	uint32_t bo_index;
+	uint32_t flags;
+	uint32_t data;
+	uint32_t vor;
+	uint32_t tor;
+};
+
+#define NOUVEAU_GEM_MAX_PUSH 512
+struct drm_nouveau_gem_pushbuf_push {
+	uint32_t bo_index;
+	uint32_t pad;
+	uint64_t offset;
+	uint64_t length;
+};
+
+struct drm_nouveau_gem_pushbuf {
+	uint32_t channel;
+	uint32_t nr_buffers;
+	uint64_t buffers;
+	uint32_t nr_relocs;
+	uint32_t nr_push;
+	uint64_t relocs;
+	uint64_t push;
+	uint32_t suffix0;
+	uint32_t suffix1;
+	uint64_t vram_available;
+	uint64_t gart_available;
+};
+
+#define NOUVEAU_GEM_CPU_PREP_NOWAIT                                  0x00000001
+#define NOUVEAU_GEM_CPU_PREP_WRITE                                   0x00000004
+struct drm_nouveau_gem_cpu_prep {
+	uint32_t handle;
+	uint32_t flags;
+};
+
+struct drm_nouveau_gem_cpu_fini {
+	uint32_t handle;
+};
+
+#define DRM_NOUVEAU_GETPARAM           0x00 /* deprecated */
+#define DRM_NOUVEAU_SETPARAM           0x01 /* deprecated */
+#define DRM_NOUVEAU_CHANNEL_ALLOC      0x02 /* deprecated */
+#define DRM_NOUVEAU_CHANNEL_FREE       0x03 /* deprecated */
+#define DRM_NOUVEAU_GROBJ_ALLOC        0x04 /* deprecated */
+#define DRM_NOUVEAU_NOTIFIEROBJ_ALLOC  0x05 /* deprecated */
+#define DRM_NOUVEAU_GPUOBJ_FREE        0x06 /* deprecated */
+#define DRM_NOUVEAU_NVIF               0x07
+#define DRM_NOUVEAU_GEM_NEW            0x40
+#define DRM_NOUVEAU_GEM_PUSHBUF        0x41
+#define DRM_NOUVEAU_GEM_CPU_PREP       0x42
+#define DRM_NOUVEAU_GEM_CPU_FINI       0x43
+#define DRM_NOUVEAU_GEM_INFO           0x44
+
+#define DRM_IOCTL_NOUVEAU_GEM_NEW            DRM_IOWR(DRM_COMMAND_BASE + DRM_NOUVEAU_GEM_NEW, struct drm_nouveau_gem_new)
+#define DRM_IOCTL_NOUVEAU_GEM_PUSHBUF        DRM_IOWR(DRM_COMMAND_BASE + DRM_NOUVEAU_GEM_PUSHBUF, struct drm_nouveau_gem_pushbuf)
+#define DRM_IOCTL_NOUVEAU_GEM_CPU_PREP       DRM_IOW (DRM_COMMAND_BASE + DRM_NOUVEAU_GEM_CPU_PREP, struct drm_nouveau_gem_cpu_prep)
+#define DRM_IOCTL_NOUVEAU_GEM_CPU_FINI       DRM_IOW (DRM_COMMAND_BASE + DRM_NOUVEAU_GEM_CPU_FINI, struct drm_nouveau_gem_cpu_fini)
+#define DRM_IOCTL_NOUVEAU_GEM_INFO           DRM_IOWR(DRM_COMMAND_BASE + DRM_NOUVEAU_GEM_INFO, struct drm_nouveau_gem_info)
+
+#endif /* __NOUVEAU_DRM_H__ */
diff --git a/sys/dev/drm/nouveau/NOTES b/sys/dev/drm/nouveau/NOTES
new file mode 100644
index 0000000000..3af22cdcdf
--- /dev/null
+++ b/sys/dev/drm/nouveau/NOTES
@@ -0,0 +1,9 @@
+softc ~= struct nouveau_drm in dev/drm/nouveau/nouveau_drm.h
+      drm_device *dev
+      pci_dev *hdmi_device
+
+struct nouveau_device in dev/drm/nouveau/core/include/core/device.h
+       pci_dev *pdev
+
+struct pci_dev in dev/drm/include/linux/pci.h
+       struct device *dev
diff --git a/sys/dev/drm/nouveau/core/core/nouveau_core_client.c b/sys/dev/drm/nouveau/core/core/nouveau_core_client.c
index 68bf067681..139adb3a2c 100644
--- a/sys/dev/drm/nouveau/core/core/nouveau_core_client.c
+++ b/sys/dev/drm/nouveau/core/core/nouveau_core_client.c
@@ -116,7 +116,7 @@ nvkm_client_notify_new(struct nouveau_client *client,
 	nv_ioctl(client, "notify new size %d\n", size);
 	if (nvif_unpack(req->v0, 0, 0, true)) {
 		nv_ioctl(client, "notify new vers %d reply %d route %02x "
-				 "token %llx\n", req->v0.version,
+				 "token %lx\n", req->v0.version,
 			 req->v0.reply, req->v0.route, req->v0.token);
 		notify->version = req->v0.version;
 		notify->size = sizeof(notify->rep.v0);
@@ -229,7 +229,7 @@ nouveau_client_create_(const char *name, u64 devname, const char *cfg,
 	atomic_set(&nv_object(client)->usecount, 2);
 
 	nouveau_object_ref(device, &client->device);
-	snprintf(client->name, sizeof(client->name), "%s", name);
+	ksnprintf(client->name, sizeof(client->name), "%s", name);
 	client->debug = nouveau_dbgopt(dbg, "CLIENT");
 	return 0;
 }
diff --git a/sys/dev/drm/nouveau/core/core/nouveau_core_engctx.c b/sys/dev/drm/nouveau/core/core/nouveau_core_engctx.c
index 84c71fad2b..8a59c1b998 100644
--- a/sys/dev/drm/nouveau/core/core/nouveau_core_engctx.c
+++ b/sys/dev/drm/nouveau/core/core/nouveau_core_engctx.c
@@ -227,7 +227,7 @@ struct nouveau_object *
 nouveau_engctx_get(struct nouveau_engine *engine, u64 addr)
 {
 	struct nouveau_engctx *engctx;
-	unsigned long flags;
+	unsigned long flags = 0;
 
 	spin_lock_irqsave(&engine->lock, flags);
 	list_for_each_entry(engctx, &engine->contexts, head) {
diff --git a/sys/dev/drm/nouveau/core/core/nouveau_core_ioctl.c b/sys/dev/drm/nouveau/core/core/nouveau_core_ioctl.c
index f7e19bfb48..9a2409317f 100644
--- a/sys/dev/drm/nouveau/core/core/nouveau_core_ioctl.c
+++ b/sys/dev/drm/nouveau/core/core/nouveau_core_ioctl.c
@@ -107,7 +107,7 @@ nvkm_ioctl_new(struct nouveau_handle *parent, void *data, u32 size)
 		return ret;
 
 	nv_ioctl(client, "new vers %d handle %08x class %08x "
-			 "route %02x token %llx\n",
+			 "route %02x token %lx\n",
 		args->v0.version, _handle, _oclass,
 		args->v0.route, args->v0.token);
 
@@ -234,7 +234,7 @@ nvkm_ioctl_rd(struct nouveau_handle *handle, void *data, u32 size)
 
 	nv_ioctl(object, "rd size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
-		nv_ioctl(object, "rd vers %d size %d addr %016llx\n",
+		nv_ioctl(object, "rd vers %d size %d addr %016lx\n",
 			args->v0.version, args->v0.size, args->v0.addr);
 		switch (args->v0.size) {
 		case 1:
@@ -276,7 +276,7 @@ nvkm_ioctl_wr(struct nouveau_handle *handle, void *data, u32 size)
 
 	nv_ioctl(object, "wr size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
-		nv_ioctl(object, "wr vers %d size %d addr %016llx data %08x\n",
+		nv_ioctl(object, "wr vers %d size %d addr %016lx data %08x\n",
 			 args->v0.version, args->v0.size, args->v0.addr,
 			 args->v0.data);
 		switch (args->v0.size) {
diff --git a/sys/dev/drm/nouveau/core/core/nouveau_core_mm.c b/sys/dev/drm/nouveau/core/core/nouveau_core_mm.c
index 7a4e0891c5..816b6d3ae8 100644
--- a/sys/dev/drm/nouveau/core/core/nouveau_core_mm.c
+++ b/sys/dev/drm/nouveau/core/core/nouveau_core_mm.c
@@ -74,7 +74,7 @@ region_head(struct nouveau_mm *mm, struct nouveau_mm_node *a, u32 size)
 	if (a->length == size)
 		return a;
 
-	b = kmalloc(sizeof(*b), GFP_KERNEL);
+	b = kmalloc(sizeof(*b), M_DRM, GFP_KERNEL);
 	if (unlikely(b == NULL))
 		return NULL;
 
@@ -142,7 +142,7 @@ region_tail(struct nouveau_mm *mm, struct nouveau_mm_node *a, u32 size)
 	if (a->length == size)
 		return a;
 
-	b = kmalloc(sizeof(*b), GFP_KERNEL);
+	b = kmalloc(sizeof(*b), M_DRM, GFP_KERNEL);
 	if (unlikely(b == NULL))
 		return NULL;
 
diff --git a/sys/dev/drm/nouveau/core/core/nouveau_core_notify.c b/sys/dev/drm/nouveau/core/core/nouveau_core_notify.c
index 76adb81bde..76d99654b1 100644
--- a/sys/dev/drm/nouveau/core/core/nouveau_core_notify.c
+++ b/sys/dev/drm/nouveau/core/core/nouveau_core_notify.c
@@ -110,7 +110,7 @@ nvkm_notify_send(struct nvkm_notify *notify, void *data, u32 size)
 	spin_unlock_irqrestore(&event->refs_lock, flags);
 
 	if (test_bit(NVKM_NOTIFY_WORK, &notify->flags)) {
-		memcpy((void *)notify->data, data, size);
+		memcpy(__DECONST(void *, notify->data), data, size);
 		schedule_work(&notify->work);
 	} else {
 		notify->data = data;
@@ -128,7 +128,7 @@ nvkm_notify_fini(struct nvkm_notify *notify)
 		spin_lock_irqsave(&notify->event->list_lock, flags);
 		list_del(&notify->head);
 		spin_unlock_irqrestore(&notify->event->list_lock, flags);
-		kfree((void *)notify->data);
+		kfree(__DECONST(void *, notify->data));
 		notify->event = NULL;
 	}
 }
@@ -150,7 +150,7 @@ nvkm_notify_init(struct nvkm_event *event, int (*func)(struct nvkm_notify *),
 			if (ret = 0, work) {
 				INIT_WORK(&notify->work, nvkm_notify_work);
 				set_bit(NVKM_NOTIFY_WORK, &notify->flags);
-				notify->data = kmalloc(reply, GFP_KERNEL);
+				notify->data = kmalloc(reply, M_DRM, GFP_KERNEL);
 				if (!notify->data)
 					ret = -ENOMEM;
 			}
diff --git a/sys/dev/drm/nouveau/core/core/nouveau_core_printk.c b/sys/dev/drm/nouveau/core/core/nouveau_core_printk.c
index 03e0060b13..2ed4b32195 100644
--- a/sys/dev/drm/nouveau/core/core/nouveau_core_printk.c
+++ b/sys/dev/drm/nouveau/core/core/nouveau_core_printk.c
@@ -65,7 +65,7 @@ nv_printk_(struct nouveau_object *object, int level, const char *fmt, ...)
 		char obuf[64], *ofmt = "";
 
 		if (object->engine) {
-			snprintf(obuf, sizeof(obuf), "[0x%08x][%p]",
+			ksnprintf(obuf, sizeof(obuf), "[0x%08x][%p]",
 				 nv_hclass(object), object);
 			ofmt = obuf;
 			subdev = object->engine;
@@ -78,7 +78,7 @@ nv_printk_(struct nouveau_object *object, int level, const char *fmt, ...)
 		if (level > nv_subdev(subdev)->debug)
 			return;
 
-		snprintf(mfmt, sizeof(mfmt), "%snouveau %c[%8s][%s]%s %s", pfx,
+		ksnprintf(mfmt, sizeof(mfmt), "%snouveau %c[%8s][%s]%s %s", pfx,
 			 name[level], nv_subdev(subdev)->name,
 			 nv_device(device)->name, ofmt, fmt);
 	} else
@@ -86,10 +86,10 @@ nv_printk_(struct nouveau_object *object, int level, const char *fmt, ...)
 		if (level > nv_client(object)->debug)
 			return;
 
-		snprintf(mfmt, sizeof(mfmt), "%snouveau %c[%8s] %s", pfx,
+		ksnprintf(mfmt, sizeof(mfmt), "%snouveau %c[%8s] %s", pfx,
 			 name[level], nv_client(object)->name, fmt);
 	} else {
-		snprintf(mfmt, sizeof(mfmt), "%snouveau: %s", pfx, fmt);
+		ksnprintf(mfmt, sizeof(mfmt), "%snouveau: %s", pfx, fmt);
 	}
 
 	va_start(args, fmt);
diff --git a/sys/dev/drm/nouveau/core/engine/copy/nouveau_engine_copy_nva3.c b/sys/dev/drm/nouveau/core/engine/copy/nouveau_engine_copy_nva3.c
index abb410ef09..aa7d4fb0cd 100644
--- a/sys/dev/drm/nouveau/core/engine/copy/nouveau_engine_copy_nva3.c
+++ b/sys/dev/drm/nouveau/core/engine/copy/nouveau_engine_copy_nva3.c
@@ -101,7 +101,7 @@ nva3_copy_intr(struct nouveau_subdev *subdev)
 	if (stat & 0x00000040) {
 		nv_error(falcon, "DISPATCH_ERROR [");
 		nouveau_enum_print(nva3_copy_isr_error_name, ssta);
-		pr_cont("] ch %d [0x%010llx %s] subc %d mthd 0x%04x data 0x%08x\n",
+		pr_cont("] ch %d [0x%010lx %s] subc %d mthd 0x%04x data 0x%08x\n",
 		       chid, inst << 12, nouveau_client_name(engctx), subc,
 		       mthd, data);
 		nv_wo32(falcon, 0x004, 0x00000040);
diff --git a/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv84.c b/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv84.c
index ea5c42f317..0adb3ef56c 100644
--- a/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv84.c
+++ b/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv84.c
@@ -128,7 +128,7 @@ nv84_crypt_intr(struct nouveau_subdev *subdev)
 	if (stat) {
 		nv_error(priv, "%s", "");
 		nouveau_bitfield_print(nv84_crypt_intr_mask, stat);
-		pr_cont(" ch %d [0x%010llx %s] mthd 0x%04x data 0x%08x\n",
+		pr_cont(" ch %d [0x%010lx %s] mthd 0x%04x data 0x%08x\n",
 		       chid, (u64)inst << 12, nouveau_client_name(engctx),
 		       mthd, data);
 	}
diff --git a/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv98.c b/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv98.c
index 5571c09534..d994d82b9a 100644
--- a/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv98.c
+++ b/sys/dev/drm/nouveau/core/engine/crypt/nouveau_engine_crypt_nv98.c
@@ -102,7 +102,7 @@ nv98_crypt_intr(struct nouveau_subdev *subdev)
 	if (stat & 0x00000040) {
 		nv_error(priv, "DISPATCH_ERROR [");
 		nouveau_enum_print(nv98_crypt_isr_error_name, ssta);
-		pr_cont("] ch %d [0x%010llx %s] subc %d mthd 0x%04x data 0x%08x\n",
+		pr_cont("] ch %d [0x%010lx %s] subc %d mthd 0x%04x data 0x%08x\n",
 		       chid, (u64)inst << 12, nouveau_client_name(engctx),
 		       subc, mthd, data);
 		nv_wr32(priv, 0x087004, 0x00000040);
diff --git a/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_base.c b/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_base.c
index 8928f7981d..2ee4dce6e0 100644
--- a/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_base.c
+++ b/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_base.c
@@ -36,7 +36,7 @@
 #include "acpi.h"
 
 static DEFINE_MUTEX(nv_devices_mutex);
-static LIST_HEAD(nv_devices);
+static LINUX_LIST_HEAD(nv_devices);
 
 struct nouveau_device *
 nouveau_device_find(u64 name)
@@ -108,10 +108,10 @@ nouveau_devobj_info(struct nouveau_object *object, void *data, u32 size)
 		break;
 	default:
 		if (device->pdev) {
-			if (pci_find_capability(device->pdev, PCI_CAP_ID_AGP))
+			if (pci_find_extcap(device->pdev->dev, PCIY_AGP, NULL) == 0)
 				args->v0.platform = NV_DEVICE_INFO_V0_AGP;
 			else
-			if (pci_is_pcie(device->pdev))
+			if (pci_find_extcap(device->pdev->dev, PCIY_EXPRESS, NULL) == 0)
 				args->v0.platform = NV_DEVICE_INFO_V0_PCIE;
 			else
 				args->v0.platform = NV_DEVICE_INFO_V0_PCI;
@@ -290,8 +290,8 @@ nouveau_devobj_ctor(struct nouveau_object *parent,
 
 	nv_ioctl(parent, "create device size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
-		nv_ioctl(parent, "create device v%d device %016llx "
-				 "disable %016llx debug0 %016llx\n",
+		nv_ioctl(parent, "create device v%d device %016lx "
+				 "disable %016lx debug0 %016lx\n",
 			 args->v0.version, args->v0.device,
 			 args->v0.disable, args->v0.debug0);
 	} else
@@ -347,7 +347,7 @@ nouveau_devobj_ctor(struct nouveau_object *parent,
 		/* read boot0 and strapping information */
 		boot0 = ioread32_native(map + 0x000000);
 		strap = ioread32_native(map + 0x101000);
-		iounmap(map);
+		iounmap(map, 102000);
 
 		/* determine chipset and derive architecture from it */
 		if ((boot0 & 0x1f000000) > 0) {
diff --git a/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_ctrl.c b/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_ctrl.c
index e34101a349..7c7d2dfc3e 100644
--- a/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_ctrl.c
+++ b/sys/dev/drm/nouveau/core/engine/device/nouveau_engine_device_ctrl.c
@@ -124,8 +124,8 @@ nouveau_control_mthd_pstate_attr(struct nouveau_object *object,
 		hi = lo;
 	}
 
-	snprintf(args->v0.name, sizeof(args->v0.name), "%s", domain->mname);
-	snprintf(args->v0.unit, sizeof(args->v0.unit), "MHz");
+	ksnprintf(args->v0.name, sizeof(args->v0.name), "%s", domain->mname);
+	ksnprintf(args->v0.unit, sizeof(args->v0.unit), "MHz");
 	args->v0.min = lo / domain->mdiv;
 	args->v0.max = hi / domain->mdiv;
 
